Index: /SMC4LRT/Outline.tex
===================================================================
--- /SMC4LRT/Outline.tex	(revision 1186)
+++ /SMC4LRT/Outline.tex	(revision 1186)
@@ -0,0 +1,353 @@
+% !TEX TS-program = pdflatex
+% !TEX encoding = UTF-8 Unicode
+
+% This is a simple template for a LaTeX document using the "article" class.
+% See "book", "report", "letter" for other types of document.
+
+\documentclass[11pt]{article} % use larger type; default would be 10pt
+
+\usepackage[utf8]{inputenc} % set input encoding (not needed with XeLaTeX)
+
+\usepackage{url}
+
+%%% Examples of Article customizations
+% These packages are optional, depending whether you want the features they provide.
+% See the LaTeX Companion or other references for full information.
+
+%%% PAGE DIMENSIONS
+\usepackage{geometry} % to change the page dimensions
+\geometry{a4paper} % or letterpaper (US) or a5paper or....
+%\geometry{margin=1cm} % for example, change the margins to 2 inches all round
+\topmargin=-0.5in
+\textheight=700pt
+% \geometry{landscape} % set up the page for landscape
+%   read geometry.pdf for detailed page layout information
+
+\usepackage{graphicx} % support the \includegraphics command and options
+
+% \usepackage[parfill]{parskip} % Activate to begin paragraphs with an empty line rather than an indent
+
+%%% PACKAGES
+\usepackage{booktabs} % for much better looking tables
+\usepackage{array} % for better arrays (eg matrices) in maths
+\usepackage{paralist} % very flexible & customisable lists (eg. enumerate/itemize, etc.)
+\usepackage{verbatim} % adds environment for commenting out blocks of text & for better verbatim
+%\usepackage{subfig} % make it possible to include more than one captioned figure/table in a single float
+% These packages are all incorporated in the memoir class to one degree or another...
+
+%%% HEADERS & FOOTERS
+\usepackage{fancyhdr} % This should be set AFTER setting up the page geometry
+\pagestyle{plain} % options: empty , plain , fancy
+\renewcommand{\headrulewidth}{0pt} % customise the layout...
+\lhead{}\chead{}\rhead{}
+\lfoot{}\cfoot{\thepage}\rfoot{}
+
+%%% SECTION TITLE APPEARANCE
+\usepackage{sectsty}
+\allsectionsfont{\sffamily\mdseries\upshape} % (See the fntguide.pdf for font help)
+% (This matches ConTeXt defaults)
+
+%%% ToC (table of contents) APPEARANCE
+\usepackage[nottoc,notlof,notlot]{tocbibind} % Put the bibliography in the ToC
+%\usepackage[titles,subfigure]{tocloft} % Alter the style of the Table of Contents
+%\renewcommand{\cftsecfont}{\rmfamily\mdseries\upshape}
+%\renewcommand{\cftsecpagefont}{\rmfamily\mdseries\upshape} % No bold!
+
+%%% END Article customizations
+
+%%% The "real" document content comes below...
+
+\title{SMC4LRT - Master Outline}
+\author{Matej Durco}
+%\date{} % Activate to display a given date or no date (if empty),
+         % otherwise the current date is printed 
+
+\begin{document}
+\maketitle
+
+\tableofcontents
+
+\section{Introduction}
+
+Title: Semantic Mapping (Component) for Language Resources
+
+\subsection{Main Goal}
+Propose a semantic mapping component for Language Resources and Technology within the context of a federated infrastructure (being constructed in the project CLARIN).
+Due to the great diversity of resources and research tasks a full alignement is not achievable. Rather the focus shall be on "soft", dynamic mapping, investigating the possibilities/methods to enable the users to control the mapping with respect to their current task,
+essentially being able to actively manipulate the recall/precision ratio of their searches. This entails the examination of user interaction with and visualization of the relevant information in the user interface and enabling the user to act upon it.
+
+
+\subsection{Method}
+We start with examining the existing Data and describing the evolving Infrastructure. 
+Then we formulate the task/function of Semantic Mapping and the requirements within the defined context, 
+followed by a design proposal for an appropriate component fitting within the infrastructure.
+In a prototype we want to deliver a proof of the concept,
+combined with an evaluation to verify the claims of fitness for the purpose.
+This evaluation is twofold. It shall verify the ability of the system to support dynamic mapping based on a set of test queries
+and secondly the usability of the ui-controls.
+
+\subsection{Expected Results}
+
+\begin{itemize}
+
+\item Specification
+\item Prototype
+\item Evaluation
+
+\end{itemize}
+
+
+\subsection{State of the Art}
+
+\begin{itemize}
+\item OLAC - Open Language Archives Community \ url{http://www.language-archives.org/}
+\item VLO - Virtual Language Observatory  \url{http://www.clarin.eu/vlo/}
+\item nature.com OpenSearch: A Case Study in OpenSearch and SRU Integration \cite{hammond2010}
+\item Kowalski (2011): Information Retrieval  \cite{kowalski2011}
+\end{itemize}
+
+\subsection{Keywords}
+
+Information retrieval, Information Discovery, IR-Systems
+ILS - Integrated Library Systems
+
+Metadata interoperability - schema mapping /semantic mapping repository, crosswalk, 
+
+Distributed content search, federated search
+
+Fuzzy Search / Similarity measures
+schema mapping / semantic mapping repository profiling?
+
+Visualization (Treemap, SOM)
+
+\section{Context}
+
+\subsection{Language Resources and Technology}
+
+While in the Digital Libraries community a consolidation generally already happened and big federated networks of digital libary repository are set up, in the field of Language Resource and Technology the landscape is still scattered, although meanwhile looking back at a decade of standardizing efforts. One main reason seems to be the complexity and diversity of the metadata associated with the resources, stemming for one from the wide range of resource types additionally complicated by dependence of different schools of thought.
+
+Need some number about the disparity in the field, number of institutes, resources, formats.
+
+This situation has been identified by the community and multiple standardization initiatives had been conducted. This process seems to have gained a new momentum thanks to large Research Infrastructure Programmes introduced by European Commission, aimed at fostering Research communities developing large-scale pan-european common infrastructures. One key player in this development is the project CLARIN
+
+\subsection{CLARIN}
+
+CLARIN - Common Language Resource and Technology Infrastructure - constituted by over 180 members from round 38 countries. The mission of this project is
+
+    create a research infrastructure that makes language resources and technologies (LRT) available to scholars of all disciplines, especially SSH large-scale pan-European collaborative effort to create, coordinate and make language resources and technology available and readily useable
+
+This shall be accomplished by setting up a federated network of centers (with federated identity management) but mainly providing resources and services in an agreed upon / coherent / uniform / consistent /standardized manner. The foundation for this goal shall be the Common or Component Metadata infrastructure, a model that caters for flexible metadata profiles, allowing to accomodate existing schemas.
+
+The embedment in the CLARIN project brings about the context of Language Resources and HLT (Human Language Technology, aka NLP - Natural Language Processing) and SSH (Social Sciences and Humanities) as the primary target user-group of CLARIN.
+CLARIN/NLP for SSH
+
+\subsection{Standards}
+
+\begin{description}
+\item[ISO12620]
+\item[Z39.50/SRU/SRW/CQL] LoC
+\item[CMDI] - (DC, OLAC, IMDI, TEI)
+\item[RDF/OWL]
+\end{description}
+
+\subsection{MD Catalogues}
+
+\subsubsection{NLP}
+
+\begin{description}
+\item[LAT, TLA] - Language Archiving Technology, now The Language Archive - provided by Max Planck Insitute for Psycholinguistics \url{http://www.mpi.nl/research/research-projects/language-archiving-technology}
+\item[OTA LR] Archiving Service provided by Oxford Text Archive \url{http://ota.oucs.ox.ac.uk/}
+\item[OLAC]
+\item[ELRA]
+\item[LDC]
+\item[DFKI/LT-World]
+\end{description}
+
+\subsubsection{(Digital) Libraries}
+
+Digital Libraries
+
+General (Libraries, Federations):
+
+\begin{description}
+\item[OCLC] \url{http://www.oclc.org}
+    world's biggest Library Federation
+\item[LoC] Library of Congress \url{http://www.loc.gov}
+\item[EU-Lib] European Library \url{http://www.theeuropeanlibrary.org/portal/organisation/handbook/accessing-collections_ en.htm}
+\item[europeana] virtual European library - cross-domain portal \url{http://www.europeana.eu/portal/}
+\end{description}
+
+\subsubsection{Content Repositories}
+
+\begin{description}
+\item[PHAIDRA] Permanent Hosting, Archiving and Indexing of Digital Resources and Assets, provided by Vienna University \url{https://phaidra.univie.ac.at/}
+\item[eSciDoc]  provided by MPG + FIZ Karlsruhe \url{https://www.escidoc.org/}
+\item[DRIVER] pan-European infrastructure of Digital Repositories \url{http://www.driver-repository.eu/}
+\item[OpenAIRE] - Open Acces Infrastructure for Research in Europe \url{http://www.openaire.eu/}
+\end{description}
+
+
+\subsection{Technologies}
+
+\subsubsection{(MD)search frameworks:}
+
+\begin{description}
+\item[Zebra/Z39.50] JZKit
+\item[Lucene/Solr]
+\item[eXist] - xml DB
+\end{description}
+
+\subsubsection{Content/Corpus Search}
+Corpus Search Systems
+\begin{description}
+\item[DDC]  - text-corpus
+\item[manatee] - text-corpus
+\item[CQP] - text-corps
+\item[TROVA] - MM annotated resources
+\item[ELAN] - MM annotated resources (editor + search)
+\end{description}
+
+
+\section{Analysis}
+
+\subsection{Data landscape}
+
+Describe situation regarding the datasets and formats 
+
+collections, profiles/Terms
+
+DC, OLAC,
+ISLE/IMDI, CHILDES, TEI, EAF!
+(CES/XCES)
+
+\subsection{Infrastructure}
+
+CMDI
+
+\subsection{Use Cases}
+
+\begin{itemize}
+
+\item MD Search employing Semantic Mapping
+\item MD Search employing Fuzzy Search
+\item Content Search
+\item Combined MEtadata Content Search
+\item Visualization of the Results - charts on facets/dimensions
+
+\item  Create and publish Virtual Collection based on complex Search (intensional/extensional)
+\item  Let Create ad-hoc corpus
+\end{itemize}
+
+\section{Semantic Mapping}
+
+
+
+Semi-transparently means, that primarily the semantic mapping shall integrate seamlessly in the interaction with the service, but it shall "explain" - offer enough information - on demand, for the user to understand its role and also being able manipulate easily.
+
+
+Facets
+Controlled Vocabularies	
+Synonym Expansion (via TermExtraction(ContentSet))
+
+Defining the Mapping - SKOS, Owl?
+
+Distinction between Metadata and content blurry
+
+\subsection{Metadata}
+CMD:Profile.Comp.Elem -> DatCat
+
+
+\subsection{Content/Annotation}
+AF + DCR + RR
+
+\subsection{Visualization}
+Landscape, Treemap, SOM
+
+Ontology Mapping and Alignement / saiks/Ontology4 4auf1.pdf
+
+\section{System Design}
+SOA
+
+\subsection{Architecture}
+
+Makes use of mulitple Components of the established infrastructure (CLARIN ):
+
+\begin{itemize}
+\item Data Category REgistry, 
+\item Relation Registry
+\item Component Registry
+\item Vocabulary Alignement Service
+\end{itemize}
+merging the pieces of information provided by those,
+offering them semi-transaprently to the user (or application) on the consumption side.
+
+
+\subsection{CMDI}
+
+MDBrowser
+MDService
+
+\subsection{Query Language}
+CQL?
+
+\subsection{User Interface}
+
+\subsubsection{Query Input}
+
+\subsubsection{Columns}
+
+\subsubsection{Summaries}
+
+\subsubsection{Differential Views}
+Visualize impact of given mapping in terms of covered dataset (number of matched records).
+
+\section{Evaluation}
+
+\subsection{Research Questions }
+
+
+\subsection{Sample Queries}
+
+\subsection{Usability}
+
+\section{Literature}
+
+\subsection{Standards}
+
+ISO 12620 - Data Category Registry
+
+LoC - SRU / CQL
+
+OAI-PMH
+
+LAF - Linguistic Annotation Framework
+
+\subsection{Books, Papers}
+A Formal Framework for Linguistic Annotation Steven Bird and Mark Liberman 2000
+
+Gerald Kowalski (2011): Information Retrieval Architecture and Algorithms
+
+Chowdhury, Gobinda G. : Introduction to modern information retrieval. - London : Facet Publ., 2010 (trocken)
+
+\subsection{DigLibs}
+
+http://publik.tuwien.ac.at/searchdb.php
+
+ISIWebOfKnowledge (/ + http://scientific.thomsonwebplus.com)
+
+\subsection{Journals, Conferences}
+
+ACM
+http://www.sigir.org/
+
+ECIR
+
+Cambridge Journals
+
+
+
+
+\bibliographystyle{plain}
+\bibliography{../lit/ir}
+
+\end{document}