Index: SMC4LRT/Expose.tex
===================================================================
--- SMC4LRT/Expose.tex	(revision 1196)
+++ SMC4LRT/Expose.tex	(revision 1196)
@@ -0,0 +1,162 @@
+% !TEX TS-program = pdflatex
+% !TEX encoding = UTF-8 Unicode
+
+% This is a simple template for a LaTeX document using the "article" class.
+% See "book", "report", "letter" for other types of document.
+
+\documentclass[11pt]{article} % use larger type; default would be 10pt
+
+\usepackage[utf8]{inputenc} % set input encoding (not needed with XeLaTeX)
+
+\usepackage{url}
+%\usepackage{svn-multi}
+
+% Subversion Information
+%\svnidlong
+%{$HeadURL: $}
+%{$LastChangedDate: $}
+%{$LastChangedRevision: $}
+%{$LastChangedBy: $}
+%\svnid{$Id$} 
+
+
+%%% Examples of Article customizations
+% These packages are optional, depending whether you want the features they provide.
+% See the LaTeX Companion or other references for full information.
+
+%%% PAGE DIMENSIONS
+\usepackage{geometry} % to change the page dimensions
+\geometry{a4paper} % or letterpaper (US) or a5paper or....
+%\geometry{margin=1cm} % for example, change the margins to 2 inches all round
+\topmargin=-0.5in
+\textheight=700pt
+% \geometry{landscape} % set up the page for landscape
+%   read geometry.pdf for detailed page layout information
+
+\usepackage{graphicx} % support the \includegraphics command and options
+
+% \usepackage[parfill]{parskip} % Activate to begin paragraphs with an empty line rather than an indent
+
+%%% PACKAGES
+\usepackage{booktabs} % for much better looking tables
+\usepackage{array} % for better arrays (eg matrices) in maths
+\usepackage{paralist} % very flexible & customisable lists (eg. enumerate/itemize, etc.)
+\usepackage{verbatim} % adds environment for commenting out blocks of text & for better verbatim
+%\usepackage{subfig} % make it possible to include more than one captioned figure/table in a single float
+% These packages are all incorporated in the memoir class to one degree or another...
+
+%%% HEADERS & FOOTERS
+\usepackage{fancyhdr} % This should be set AFTER setting up the page geometry
+\pagestyle{plain} % options: empty , plain , fancy
+\renewcommand{\headrulewidth}{0pt} % customise the layout...
+\lhead{}\chead{}\rhead{}
+\lfoot{}\cfoot{\thepage}\rfoot{}
+
+%%% SECTION TITLE APPEARANCE
+\usepackage{sectsty}
+\allsectionsfont{\sffamily\mdseries\upshape} % (See the fntguide.pdf for font help)
+% (This matches ConTeXt defaults)
+
+%%% ToC (table of contents) APPEARANCE
+\usepackage[nottoc,notlof,notlot]{tocbibind} % Put the bibliography in the ToC
+%\usepackage[titles,subfigure]{tocloft} % Alter the style of the Table of Contents
+%\renewcommand{\cftsecfont}{\rmfamily\mdseries\upshape}
+%\renewcommand{\cftsecpagefont}{\rmfamily\mdseries\upshape} % No bold!
+
+%%% END Article customizations
+
+%%% The "real" document content comes below...
+
+\title{SMC4LRT - \\ Semantic Mapping Component for Language Resources and Technology}
+\author{Durco Matej, 0005416}
+%\date{} % Activate to display a given date or no date (if empty),
+         % otherwise the current date is printed 
+
+\begin{document}
+\maketitle
+
+\section{Main Goal}
+
+We propose a component that shall enhance search functionality over a large heterogeneous collection of metadata descriptions of Language Resources and Technology (LRT). By applying semantic web technology the user shall be given both better recall through query expansion based on related categories/concepts and new means of exploring the dataset/knowledge-base via ontology-driven browsing.
+
+A trivial example for a concept-based query expansion: 
+Confronted with a user query: \texttt{Actor.Name = Sue} and knowing that \texttt{Actor} is equivalent or similar to \texttt{Person} and \texttt{Name} is synonym to \texttt{FullName} the expanded query could look like:
+\texttt{Actor.Name = Sue OR Actor.FullName = Sue OR Person.Name =  Sue OR Person.FullName= is Sue}
+
+Another example concerning instance mapping: the user looking for all resource produced by or linked to a given institution, does not have to guess or care for various spellings of the name of the institution used in the description of the resources, but rather can browse through a controlled vocabulary of institutions and see all the resources of given institution. While this could be achieved by simple normalizing of the literal-values (and indeed that definitely has to be one processing step), the linking to an ontology, enables to user to also continue browsing the ontology to find institutions that are related to the original institution by means of being concerned with similar topics and retrieve a union of resources for such resulting cluster. Thus in general the user is enabled to work with the data based on information that is not present in the original dataset.
+
+All these scenarios require a preprocessing step, that would produce the underlying linkage, both between categories/concepts and between instances (mapping literal values to entities). We refer to this task as semantic mapping, that shall be accomplished by coresponding "Semantic Mapping Component". In this work the focus lies on the process/method, i.e. on the specification and (prototypical) implementation of the component rather than trying to establish some final/accomplished mapping. Although a tentative/naive alignement on a subset of the data will be proposed, this will be mainly used for evaluation and shall serve as basis for discussion with domain experts aiming at creating the actual sensible mappings usable for real tasks.
+
+Actually due to the great diversity of resources and research tasks  such a "final" complete mapping/alignement does not seem achievable at all. Therefore also the focus shall be on "soft", dynamic mapping, investigating the possibilities/methods to enable the users to adapt the mapping or apply different mappings with respect to their current task or research question,
+essentially being able to actively manipulate the recall/precision ratio of their searches. This entails the examination of user interaction with and visualization of the relevant information in the user interface and enabling the user to act upon it.
+
+\section{Method}
+We start with examining the existing data and describing the evolving Infrastructure in which the components are to be embedded.
+Then we formulate the task/function of Semantic Search on concept and on individuals level
+and the underlying Semantic Mapping and the requirements within the defined context, 
+followed by a design proposal for an appropriate component fitting within the infrastructure.
+especially with focus on the feasibility of employing ontology mapping and alignement techniques and tools for the creation of mappings.
+
+In a prototype we want to deliver a proof of the concept,
+combined with an evaluation to verify the claims of fitness for the purpose.
+This evaluation is twofold. It shall verify the ability of the system to support dynamic mapping based on a set of test queries
+and secondly the usability of the ui-controls.
+
+
++? Identify hooks into LOD?
+
+
+a) define/use semantic relations between categories (RelationRegistry)
+b) employ ontological resources to enhance search in the dataset (SemanticSearch) 
+c) specify a translation instructions for expressing dataset in rdf  (LinkedData)
+
+
+\section{Expected Results}
+
+The main result of this work will be a specification of the pair of components the Semantic Search and the underlying Semantic Mapping. These propositions will be supported by a proof-of-concept implementation of these components and an evaluation of querying the dataset comparing traditional search and semantic search.
+
+One important by-product of the work will be the original dataset expressed as RDF with links into existing datasets/ontologies/knowledgebases, building a base for another nucleus of Linked Open Data.
+
+\begin{itemize}
+\item [Specification] definition of a mapping mechanism 
+\item [Prototype] proof of concept implementation 
+\item [Evaluation] evaluation results of querying the dataset comparing traditional search and semantic search
+\item [LinkedData] translation of the source dataset to RDF-based format with links into existing datasets/ontologies/knowledgebases
+
+\end{itemize}
+
+
+\section{State of the Art}
+
+One current tightly related work is the VLO - Virtual Language Observatory  \footnote{\url{http://www.clarin.eu/vlo/}} \cite{VanUytvanck2010}, being developed within the CLARIN-project. This application operates on the same collection of data as is discussed in this work, however lead by the guiding principle to simplify the search for the user it employs a faceted search, mapping manually the appropriate metadata-fields from the different schemas/profiles to 10 fixed facets.
+
+From the knowledge management and semantic web point of view, LT-World, \footnote{\url{http://www.lt-world.org/}} \cite{Joerg2010}
+the ontology-based portal for Language Resources and technology being developed at DFKI \footnote{Deutsches Forschungszentrum fÃŒr KÃŒnstliche Intelligenz} is a prominent resource providing the information about the entities (Institutions, Persons, Project, Tools, etc.) in this field of study.
+
+Linked Open Data
+
+VAS - Catch Plus
+
+OAEI
+
+The starting point for the investigation of work regarding ontology mapping is the overview of the field by Kalfouglou \cite{Kalfoglou2003}.
+
+\section{Keywords}
+
+Metadata interoperability, Ontology Mapping, Schema mapping, Crosswalk, Similarity measures, LinkedData
+Fuzzy Search, Visual Search?
+schema-based ontology alignment
+
+Language Resources and Technology, LRT/NLP/HLT
+
+Ontology Visualization
+
+Federated Search, Distributed Content Search
+(ILS - Integrated Library Systems)
+
+
+\bibliographystyle{plain}
+\bibliography{../../../2bib/lingua,../../../2bib/ontolingua,../../../2bib/semweb}
+
+
+\end{document}