Index: MDService2/branches/MDService_simple3/src/eu/clarin/cmdi/mdservice/action/GenericAction.java
===================================================================
--- MDService2/branches/MDService_simple3/src/eu/clarin/cmdi/mdservice/action/GenericAction.java	(revision 1516)
+++ MDService2/branches/MDService_simple3/src/eu/clarin/cmdi/mdservice/action/GenericAction.java	(revision 1517)
@@ -405,5 +405,5 @@
 		}
 			
-		if (format.equals("xml")) {			
+		if (getFormat().equals("xml")) {			
 			resultStream = sourceStream;	
 		}else {
Index: MDService2/branches/MDService_simple3/src/eu/clarin/cmdi/mdservice/model/Query.java
===================================================================
--- MDService2/branches/MDService_simple3/src/eu/clarin/cmdi/mdservice/model/Query.java	(revision 1516)
+++ MDService2/branches/MDService_simple3/src/eu/clarin/cmdi/mdservice/model/Query.java	(revision 1517)
@@ -31,5 +31,5 @@
 
 public class Query {	
-	public static String COLLECTIONS = "collections";
+	public static String COLLECTION = "collection";
 	public static String COLUMNS = "columns";
 	public static String MODEL = "model";
@@ -358,4 +358,8 @@
 		if (type.equals(MODEL)) {
 			targetRequest = fromCMDIndex2Xpath() + "&maxdepth=" + getMaxdepth()  ; /* + "&maxdepth=" + getMaxdepth() );  "&collection=" + getCollection() + */
+		} 
+		else if (type.equals(COLLECTION)) {
+			targetRequest = getCollection() + "&maxdepth=" + getMaxdepth()  ; /* + "&maxdepth=" + getMaxdepth() );  "&collection=" + getCollection() + */
+
 		} else if (type.equals(SRUEXTERN)) {
 			targetRequest = "";//fromCMDIndex2Xpath() + "&maxdepth=" + getMaxdepth()  ; /* + "&maxdepth=" + getMaxdepth() );  "&collection=" + getCollection() + */
Index: MDService2/branches/MDService_simple3/src/struts.xml
===================================================================
--- MDService2/branches/MDService_simple3/src/struts.xml	(revision 1516)
+++ MDService2/branches/MDService_simple3/src/struts.xml	(revision 1517)
@@ -8,10 +8,7 @@
 	<constant name="struts.devMode" value="false" />
 	<constant name="struts.serve.static" value="false"/>
-	
 
 	<package name="basicstruts2" extends="struts-default">
-
- 		<default-action-ref name="catchall" />
- 				
+ 		<default-action-ref name="catchall" /> 				
 		<global-results>
 			    <!-- <result name="exception">/Exception.jsp</result>--> 
@@ -36,26 +33,8 @@
         </global-exception-mappings>
 		
-        <!-- If no class attribute is specified the framework will assume success and 
-        render the result index.jsp -->
+        <!-- If no class attribute is specified the framework will assume success and render the result index.jsp -->
         <!-- If no name value for the result node is specified the success value is the default -->
-		<!-- <action name="index">
-			<result>/index.jsp</result>
-		</action>
-		 
-		 
-		<action name="/?*">
-			<result>/index.jsp?{1}</result>
-		</action>
--->
-	<!-- 	<action name="/?*" class="eu.clarin.cmdi.mdservice.action.StaticAction" method="execute"> 
-			   <param name="actionkey">static</param>
-			   <param name="format">htmlpage</param>
-			   <param name="q">index</param>			   
-			    <result type="stream">			    
-			        <param name="contentType">${getActionContentType()}</param>
-			        <param name="inputName">resultStream</param>			        
-			    </result>
-		</action>
-		-->
+		<!-- <action name="index"><result>/index.jsp</result></action> -->
+<!-- BASIC ACTIONS -->		 
 		<action name="index" class="eu.clarin.cmdi.mdservice.action.StaticAction" method="execute"> 
 			   <param name="actionkey">static</param>
@@ -87,6 +66,60 @@
 			    </result>
 		</action>
-
-		
+		
+<!-- REPO ACTIONS -->
+		<action name="model/*" class="eu.clarin.cmdi.mdservice.action.RepoAction" method="execute">
+			<param name="q">{1}</param> 
+			<param name="actionkey">model</param>			   
+			<result type="stream">			    
+				<param name="contentType">${getActionContentType()}</param>
+				<param name="inputName">resultStream</param>			        
+			</result>
+		</action>
+		
+		<action name="search/*" class="eu.clarin.cmdi.mdservice.action.RepoAction" method="execute">
+			<param name="q">{*}</param> 
+			<param name="actionkey">search</param>			   
+			<result type="stream">			    
+				<param name="contentType">${getActionContentType()}</param>
+				<param name="inputName">resultStream</param>			        
+			</result>
+		</action>
+		
+		<action name="record" class="eu.clarin.cmdi.mdservice.action.RepoAction" method="execute">			 
+			<param name="actionkey">record</param>			   
+			<result type="stream">			    
+				<param name="contentType">${getActionContentType()}</param>
+				<param name="inputName">resultStream</param>			        
+			</result>
+		</action>
+		
+		<action name="collection" class="eu.clarin.cmdi.mdservice.action.RepoAction" method="execute">			
+			<param name="actionkey">collection</param>
+			<result type="stream">		
+				<param name="contentType">${getActionContentType()}</param>			        
+				<param name="inputName">resultStream</param>
+			</result>
+		</action>
+		
+		<action name="sru" class="eu.clarin.cmdi.mdservice.action.SRUAction" method="execute"> 
+			<param name="q">{1}</param>
+			<result name="success" type="stream">			       
+				<param name="contentType">text/xml</param> 
+				<param name="inputName">resultStream</param>			        
+			</result>
+			<result name="error" type="stream">			       
+				<param name="contentType">text/xml</param> 
+				<param name="inputName">${getDiagnosticStreamName()}</param>			        
+			</result>
+		</action>
+		
+		<action name="pazpar2/" class="eu.clarin.cmdi.mdservice.action.Pz2Action" method="execute">
+			<result name="success" type="stream">			       
+				<param name="contentType">${getActionContentType()}</param> 
+				<param name="inputName">resultStream</param>			        
+			</result>
+		</action>
+		
+<!-- REGISTRY PROXY ACTIONS -->		
 		<action name="comp/*" class="eu.clarin.cmdi.mdservice.action.CompRegistryProxyAction" method="execute">
 			   	<param name="compid">{1}</param>
@@ -142,5 +175,6 @@
 			    </result>
 		</action>
-		
+
+<!-- SPECIAL ACTIONS - Workspace(save), VirtualCollection(publish), Admin(cache) --> 
 		<action name="workspaceprofile/*" class="eu.clarin.cmdi.mdservice.action.WorkspaceAction" method="execute">
 			   <param name="format">JSON</param>
@@ -161,8 +195,4 @@
 			   <param name="type">{1}</param> 
 			   <param name="qsid">{2}</param>
-			   <!-- <param name="data">{1}</param>	
-			   <param name="actionkey"></param>	 
-			    -->	    
-			    
 			   <result type="stream">			   
 			        <param name="contentType">text/xml</param>
@@ -195,61 +225,4 @@
 		</action>
 		
-		<action name="pazpar2/" class="eu.clarin.cmdi.mdservice.action.Pz2Action" method="execute">
-			   <result name="success" type="stream">			       
-			        <param name="contentType">${getActionContentType()}</param> 
-			        <param name="inputName">resultStream</param>			        
-			    </result>
-		</action>
-		
-		<action name="sru/*" class="eu.clarin.cmdi.mdservice.action.SRUAction" method="execute"> 
-			   <param name="q">{1}</param>
-			   <result name="success" type="stream">			       
-			        <param name="contentType">text/xml</param> 
-			        <param name="inputName">resultStream</param>			        
-			    </result>
-			    <result name="error" type="stream">			       
-			        <param name="contentType">text/xml</param> 
-			        <param name="inputName">${getDiagnosticStreamName()}</param>			        
-			    </result>
-		</action>
-		
-		<action name="model/*" class="eu.clarin.cmdi.mdservice.action.RepoAction" method="execute">
-			<param name="q">{1}</param> 
-			   <param name="actionkey">model</param>			   
-			    <result type="stream">			    
-			        <param name="contentType">${getActionContentType()}</param>
-			        <param name="inputName">resultStream</param>			        
-			    </result>
-		</action>
-
-		<action name="search/*" class="eu.clarin.cmdi.mdservice.action.RepoAction" method="execute">
-			   <param name="q">{*}</param> 
-			   <param name="actionkey">search</param>			   
-			    <result type="stream">			    
-			        <param name="contentType">${getActionContentType()}</param>
-			        <param name="inputName">resultStream</param>			        
-			    </result>
-		</action>
-		
-		<action name="record/*" class="eu.clarin.cmdi.mdservice.action.RepoAction" method="execute">
-			   <param name="q">{1}</param> 
-			   <param name="actionkey">record</param>			   
-			    <result type="stream">			    
-			        <param name="contentType">${getActionContentType()}</param>
-			        <param name="inputName">resultStream</param>			        
-			    </result>
-		</action>
-
-	  <action name="collections/*" class="eu.clarin.cmdi.mdservice.action.RepoAction" method="execute">
-			   	<param name="format">{1}</param>
-			   	<param name="actionkey">collections</param>
-			    <result type="stream">		
-			        <param name="contentType">${getActionContentType()}</param>			        
-			        <param name="inputName">resultStream</param>
-			    </result>
-		</action>
-
-		
 	</package>
-
 </struts>